let serial;

let byte1, byte2, byte3, byte4, high, low;
let value = 0;

function setup() {
  createCanvas(400, 400);
  
  // Instantiate our SerialPort object
  serial = new p5.SerialPort();

  // Let's list the ports available
  let portlist = serial.list();

  // Assuming our Arduino is connected, let's open the connection to it
  // Change this to the name of your arduino's serial port
  serial.open("/dev/tty.usbserial-AB0MKVTQ");

  // Register some callbacks

  // When we connect to the underlying server
  serial.on("connected", serverConnected);

  // When we get a list of serial ports that are available
  serial.on("list", gotList);

  // When we some data from the serial port
  serial.on("data", gotData);

  // When or if we get an error
  serial.on("error", gotError);

  // When our serial port is opened and ready for read/write
  serial.on("open", gotOpen);
}

// We are connected and ready to go
function serverConnected() {
  print("We are connected!");
}

// Got the list of ports
function gotList(thelist) {
  // theList is an array of their names
  for (let i = 0; i < thelist.length; i++) {
    // Display in the console
    print(i + " " + thelist[i]);
  }
}

// Connected to our serial device
function gotOpen() {
  print("Serial Port is open!");
}

// Ut oh, here is an error, let's log it
function gotError(theerror) {
  print(theerror);
}

// There is data available to work with from the serial port
function gotData() {
  let currentString = serial.readStringUntil("\r\n");
  console.log(currentString);
}

function draw() {
  background(value);
  while (serial.available() > 0) {
    byte1 = byte2;
    byte2 = byte3;
    byte3 = byte4;
    byte4 = low;
    low = high;
    high = serial.read();

    if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4)) {
      //Reset the preamble.
      byte1 = byte2 = byte3 = byte4 = 0;
      value = 256 * high + low;
      print("Counter is " + value);
      value = value >> 2;
    }
  }
}
